/*
 ** moments.h
 ** Login : <nicolas.burrus@ensta.fr>
 ** Started on  Thu Jun 23 23:26:21 2005 Nicolas Burrus
 ** $Id$
 ** 
 ** Copyright (C) 2005, 2006, 2007 Nicolas Burrus
 ** This program is free software; you can redistribute it and/or modify
 ** it under the terms of the GNU General Public License as published by
 ** the Free Software Foundation; either version 2 of the License, or
 ** (at your option) any later version.
 ** 
 ** This program is distributed in the hope that it will be useful,
 ** but WITHOUT ANY WARRANTY; without even the implied warranty of
 ** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 ** GNU General Public License for more details.
 ** 
 ** You should have received a copy of the GNU General Public License
 ** along with this program; if not, write to the Free Software
 ** Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */

#ifndef   	NTK_STATS_ESTIMATION_H_
# define   	NTK_STATS_ESTIMATION_H_

# include <ntk/core.h>
# include <ntk/stats/distributions.h>
# include <vcl_map.h>

namespace ntk
{
 	
  struct WeibullEstimates
  {
    double beta;
    double etha;
    double gamma;
    double logl;
  };
   
  void estimate_weibull(vcl_map<double,double> distribution, 
                        WeibullEstimates& init);
  
  void estimate_weibull3(vcl_map<double,double> distribution, 
                         WeibullEstimates& init);

  // Finds parameters b, n in the confidence region induced by confidence
  // which maximize wblinv(c, b, n)
	WeibullEstimates
  estimate_weibull_upper_bounds(vcl_map<double,double> distribution,
                                const WeibullEstimates& best_params,
                                double confidence,
                                double c);
  
  double estimate_lognormal(const vcl_map<double,double>& distrib,
                            LogNormalDistrib::Params& init);
  
  double estimate_fishertippett(const vcl_map<double,double>& distrib,
                                FisherTippettDistrib::Params& init);
  
  double estimate_frechet(const vcl_map<double,double>& distrib,
                          FrechetDistrib::Params& init);
  
  double estimate_frechet3(const vcl_map<double,double>& distrib,
                           FrechetDistrib::Params& init);
}

#endif 		  // !NTK_STATS_ESTIMATION_H_
