//
// pointer.h
// 
// Author: Nicolas Burrus <nicolas.burrus@ensta.fr>, (C) 2007
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
//

#ifndef NTK_UTILS_pointer_H
# define NTK_UTILS_pointer_H

# include <ntk/core.h>
# include <vcl_memory.h>
# include <boost/enable_shared_from_this.hpp>

template <class T> class auto_ptr;

namespace ntk 
{
  template<typename T> struct NoopDeleter { void operator() (T* x) {} };
  template<typename T> shared_ptr<T> dummy_shared_ptr__no_not_use(T* p)
  { return shared_ptr<T>(p, NoopDeleter<T>()); }
  
  template <class T>
      vcl_auto_ptr<T> to_auto_ptr(T* t) { return vcl_auto_ptr<T>(t); }
}

namespace ntk
{
  template <class T>
  class enable_shared_utils : public boost::enable_shared_from_this<T>
  {
  };
  
}

#endif // ndef NTK_UTILS_pointer_H
