/*
** test-imageobserver.cc
** Login : <nicolas.burrus@ensta.fr>
** Started on  Wed Oct 18 12:51:34 2006 Nicolas Burrus
** $Id$
** 
** Copyright (C) 2006 Nicolas Burrus
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
** 
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
** 
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/

#include <ntk/gui/imageviewer.h>
#include <ntk/vxl/all.h>

#include <vnl/vnl_random.h>

#include <QApplication>
#include <QThread>

using namespace ntk;

class RandomImageSubject : public QThread, public ImageSubject
{
public:
  RandomImageSubject()
    : current_image(256,256)
  {}

public:
  const vil_image_view<vxl_byte>& currentImage() const 
  { return current_image; }

public:
  virtual void run()
  {
    while(true)
    {
      for_all_xy(current_image)
        current_image(x,y) = rgen(256);
      notifyObservers();
      sleep(1);
    }
  }

private:
  vil_image_view<vxl_byte> current_image;
  vnl_random rgen;
};

int main(int argc, char** argv)
{
  QApplication app(argc, argv);
  RandomImageSubject s;
  s.start();

  ImageViewerObserver observer;
  observer.initialize();
  s.attachObserver(observer);
  observer.show();
  
  return app.exec();
}
