/*
** test-threadpool.cc
** Login : <nicolas.burrus@ensta.fr>
** Started on  Wed Oct 18 12:51:34 2006 Nicolas Burrus
** $Id$
** 
** Copyright (C) 2006 Nicolas Burrus
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
** 
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
** 
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/

#include <ntk/gui/imageviewer.h>
#include <ntk/utils/taskpool.h>
#include <ntk/utils/task.h>
#include <ntk/vxl/all.h>

#include <vnl/vnl_random.h>

#include <QApplication>
#include <QThread>

using namespace ntk;

class TestTask : public Task
{
protected:
  void startTask()
  {
    static int id = 0;
    
    static QMutex mutex;
    mutex.lock();
    unsigned prev_id = id++;
    mutex.unlock();
    
    static QMutex mutex2;
    mutex2.lock();
    std::cerr << "Starting task " << prev_id << std::endl;    
    mutex2.unlock();
    
    sleep((unsigned)((rand()*5.)/RAND_MAX));
    
    mutex2.lock();
    std::cerr << "Ending task " << prev_id << std::endl;
    mutex2.unlock();
  }
};

int main(int argc, char** argv)
{
  QCoreApplication app(argc, argv);
  TaskPool p (10);
  for (int i = 0; i < 100; ++i)    
    p.addTask(shared_ptr<Task>(new TestTask()));
  p.wait();
}
