/*
  ==============================================================================

  This is an automatically generated file created by the Jucer!

  Creation date:  11 Sep 2007 5:03:17 pm

  Be careful when adding custom code to these files, as only the code within
  the "//[xyz]" and "//[/xyz]" sections will be retained when the file is loaded
  and re-saved.

  Jucer version: 1.11

  ------------------------------------------------------------------------------

  The Jucer is part of the JUCE library - "Jules' Utility Class Extensions"
  Copyright 2004-6 by Raw Material Software ltd.

  ==============================================================================
*/

//[Headers] You can add your own extra header files here...
#include "learning_window.h"
#include "ac_properties.h"
//[/Headers]

#include <ntk/ntk_with_macros.h>
#include "learning_panel.h"


//[MiscUserDefs] You can add your own user definitions and misc code here...
//[/MiscUserDefs]

//==============================================================================
LearningPanel::LearningPanel (PropertySetSubject& properties)
    : m_properties(properties),
      m_panel (0),
      m_learn_button (0)
{
  //[Constructor_pre] You can add your own custom stuff here..
  
  //[/Constructor_pre]

  addAndMakeVisible (m_panel = new PropertyPanel());
  m_panel->setName (T("Panel"));

  addAndMakeVisible (m_learn_button = new TextButton (T("learn")));
  m_learn_button->setButtonText (T("Learn!"));
  m_learn_button->addButtonListener (this);


  //[UserPreSize]
  //[/UserPreSize]

  setSize (600, 400);

  //[Constructor] You can add your own custom stuff here..
  Array<PropertyComponent*> components;

  components.clear();
  components.add(new FileChoice(m_properties, "Threshold database",
                 "threshold_database", false, true, T("*.xml")));
  m_panel->addSection("Files", components);

  components.clear();
  components.add(new AcPropertyText(m_properties, "Iterations", "learning-iterations"));
  components.add(new AcPropertyText(m_properties, "Images width", "learning-width"));
  components.add(new AcPropertyText(m_properties, "Images height", "learning-height"));  
  m_panel->addSection("Learning", components);
  
  components.clear();
  components.add(new InitializerChoice(m_properties));
  m_panel->addSection("Main algorithm", components);

  components.clear();
  components.add(new AcPropertyBoolean(m_properties, "Use mean", "use_mean"));
  components.add(new AcPropertyBoolean(m_properties, "Use deviation", "use_deviation"));
  components.add(new AcPropertyBoolean(m_properties, "Use frontier", "use_frontier"));
  m_panel->addSection("Selector", components);

  components.clear();
  components.add(new AcPropertyText(m_properties, "Sigma", "egbis-sigma"));
  components.add(new AcPropertyText(m_properties, "K", "egbis-k"));
  components.add(new AcPropertyText(m_properties, "min_size", "egbis-min-size"));
  m_panel->addSection("Egbis", components);

  components.clear();
  components.add(new AcPropertyText(m_properties, "Complexity", "srm-complexity"));
  m_panel->addSection("SRM", components);
  
  components.clear();
  components.add(new AcPropertyText(m_properties, "HS", "edison-hs"));
  components.add(new AcPropertyText(m_properties, "HR", "edison-hr"));
  components.add(new AcPropertyText(m_properties, "Min area", "edison-min-area"));
  m_panel->addSection("Edison", components);
  
  components.clear();
  components.add(new AcPropertyText(m_properties, "Sigma", "watershed-sigma"));
  m_panel->addSection("Watershed", components);
  //[/Constructor]
}

LearningPanel::~LearningPanel()
{
  //[Destructor_pre]. You can add your own custom destruction code here..
  //[/Destructor_pre]

  deleteAndZero (m_panel);
  deleteAndZero (m_learn_button);

  //[Destructor]. You can add your own custom destruction code here..
  //[/Destructor]
}

//==============================================================================
void LearningPanel::paint (Graphics& g)
{
    //[UserPrePaint] Add your own custom painting code here..
    //[/UserPrePaint]

    //[UserPaint] Add your own custom painting code here..
    //[/UserPaint]
}

void LearningPanel::resized()
{
    m_panel->setBounds (5, 5, getWidth() - 10, getHeight() - 39);
    m_learn_button->setBounds (proportionOfWidth (0.5000f) - ((104) / 2), getHeight() - 29, 104, 24);
    //[UserResized] Add your own custom resize handling here..
    //[/UserResized]
}

void LearningPanel::buttonClicked (Button* buttonThatWasClicked)
{
    //[UserbuttonClicked_Pre]
    //[/UserbuttonClicked_Pre]

    if (buttonThatWasClicked == m_learn_button)
    {
      //[UserButtonCode_m_learn_button] -- add your button handler code here..
      // Force acsegmentor for the main algorithm.
      m_properties.setValue("segmentor", T("acsegmentor"));
      
      ntk_log() << "Starting learning...";
      ntk_log() << (PropertySet&)m_properties;
      LearningWindow* window = new LearningWindow(m_properties);
      window->setVisible(true);
      window->startLearning();
      //[/UserButtonCode_m_learn_button]
    }

    //[UserbuttonClicked_Post]
    //[/UserbuttonClicked_Post]
}



//[MiscUserCode] You can add your own definitions of your custom methods or any other code here...
//[/MiscUserCode]


//==============================================================================
#if 0
/*  -- Jucer information section --

  This is where the Jucer puts all of its metadata, so don't change anything in here!

BEGIN_JUCER_METADATA

<JUCER_COMPONENT documentType="Component" className="LearningPanel" componentName=""
                 parentClasses="public Component" constructorParams="PropertySetSubject&amp; properties"
                 variableInitialisers="m_properties(properties)&#10;" snapPixels="8"
                 snapActive="1" snapShown="1" overlayOpacity="0.330000013" fixedSize="0"
                 initialWidth="600" initialHeight="400">
  <BACKGROUND backgroundColour="ffffff"/>
  <GENERICCOMPONENT name="Panel" id="6895a6f1fffbba29" memberName="m_panel" virtualName=""
                    explicitFocusOrder="0" pos="5 5 10M 39M" class="PropertyPanel"
                    params=""/>
  <TEXTBUTTON name="learn" id="d83bb36db8048fed" memberName="m_learn_button"
              virtualName="" explicitFocusOrder="0" pos="50%c 29R 104 24" buttonText="Learn!"
              connectedEdges="0" needsCallback="1" radioGroupId="0"/>
</JUCER_COMPONENT>

END_JUCER_METADATA
*/
#endif
